const admZip = require('adm-zip');
const fs = require('fs');

const route = (router) => {
  router.get('/download', (async (req, res) => {
    try {
      console.log('/download', req.query);
      const aplicacao = req.query.aplicacao;
      const versao = req.query.versao;

      const dirApp = '../../../../../assistant-sistemas/';
      
      /** Repositório */
      let dir = `${dirApp + aplicacao}/${versao}`;
      dir = path.join(`${__dirname}`, dir);

      /** Se não existir retorna */
      if (!fs.existsSync(dir)) {
        return res.send('Aplicação não disponível!');
      }

      /** Repositorio zipadao */
      const name = `${dirApp + aplicacao}-${versao}.zip`;
      const dirZip = path.join(`${__dirname}`, name);
      const zip = new admZip();
      let files = [];
      files = fs.readdirSync(dir);

      files.forEach((file) => {
        if (fs.statSync(`${dir}/${file}`).isDirectory()) {
          zip.addLocalFolder(path.resolve(dir, file), file);
        } else {
          zip.addLocalFile(`${dir}/${file}`);
        }
      });

      zip.writeZip(dirZip);
      const buff = zip.toBuffer();
      /** arquivo nome DANIEL-V0.0.1.zip */
      fs.unlinkSync(dirZip);

      /** Permite o download do zip */
      return res.send(buff);
    } catch (error) {
      res.send(error);
    }
  }));
}

module.exports = route;