import { Component, Prop } from 'vue-property-decorator';
import { ZdComponent } from '@zeedhi/vuetify';
import { CustomPagination as CustomPaginationClass } from './common/custom-pagination';

@Component
export default class CustomPagination extends ZdComponent {
    @Prop({ type: [String, Number] }) public length!: string | number;

    @Prop({ type: [String, Number] }) public page!: string | number;

    public instance!: CustomPaginationClass;

    public instanceType: typeof CustomPaginationClass = CustomPaginationClass;

    public changePage(page : Number) {
        this.instance.changePage(this.$el as HTMLElement, page);
    }
}
